import { Type } from '@angular/core';
import { BatchedMesh, Box3, Object3DEventMap } from 'three';
import { Camera } from 'three/src/cameras/Camera.js';
import { BufferGeometry } from 'three/src/core/BufferGeometry.js';
import { Material } from 'three/src/materials/Material.js';
import { Sphere } from 'three/src/math/Sphere.js';
import { Vector3 } from 'three/src/math/Vector3.js';
import { ThMesh } from './ThMesh';
import * as i0 from "@angular/core";
export declare class ThBatchedMesh<T extends BatchedMesh = BatchedMesh, TARGS = [
    maxInstanceCount: number,
    maxVertexCount: number,
    maxIndexCount?: number,
    material?: Material
]> extends ThMesh<BufferGeometry, Material, Object3DEventMap, T, TARGS> {
    getType(): Type<BatchedMesh>;
    set boundingBox(value: Box3 | null | [min: Vector3, max: Vector3]);
    get boundingBox(): (Box3 | null) | undefined;
    set boundingSphere(value: Sphere | null | [center: Vector3, radius: number]);
    get boundingSphere(): (Sphere | null) | undefined;
    set customSort(value: ((this: T, list: Array<{
        start: number;
        count: number;
        z: number;
    }>, camera: Camera) => void) | null);
    get customSort(): (((this: T, list: Array<{
        start: number;
        count: number;
        z: number;
    }>, camera: Camera) => void) | null) | undefined;
    set perObjectFrustumCulled(value: boolean);
    get perObjectFrustumCulled(): boolean | undefined;
    set sortObjects(value: boolean);
    get sortObjects(): boolean | undefined;
    get maxInstanceCount(): number | undefined;
    get instanceCount(): number | undefined;
    get unusedVertexCount(): number | undefined;
    get unusedIndexCount(): number | undefined;
    get isBatchedMesh(): true | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThBatchedMesh<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThBatchedMesh<any, any>, "th-batchedMesh", never, { "boundingBox": { "alias": "boundingBox"; "required": false; }; "boundingSphere": { "alias": "boundingSphere"; "required": false; }; "customSort": { "alias": "customSort"; "required": false; }; "perObjectFrustumCulled": { "alias": "perObjectFrustumCulled"; "required": false; }; "sortObjects": { "alias": "sortObjects"; "required": false; }; }, {}, never, ["*"], false, never>;
}
