import { Type } from '@angular/core';
import { CompressedTexture, CompressedTextureMipmap } from 'three';
import { CompressedPixelFormat, MagnificationTextureFilter, Mapping, MinificationTextureFilter, TextureDataType, Wrapping } from 'three/src/constants.js';
import { ThTexture } from './ThTexture';
import * as i0 from "@angular/core";
export declare class ThCompressedTexture<T extends CompressedTexture = CompressedTexture, TARGS = [
    mipmaps?: CompressedTextureMipmap[],
    width?: number,
    height?: number,
    format?: CompressedPixelFormat,
    type?: TextureDataType,
    mapping?: Mapping,
    wrapS?: Wrapping,
    wrapT?: Wrapping,
    magFilter?: MagnificationTextureFilter,
    minFilter?: MinificationTextureFilter,
    anisotropy?: number,
    colorSpace?: string
]> extends ThTexture<T, TARGS> {
    getType(): Type<CompressedTexture>;
    get isCompressedTexture(): true | undefined;
    get image(): {
        width: number;
        height: number;
    } | undefined;
    set image(value: {
        width: number;
        height: number;
    });
    set mipmaps(value: CompressedTextureMipmap[] | undefined);
    get mipmaps(): (CompressedTextureMipmap[] | undefined) | undefined;
    set format(value: CompressedPixelFormat);
    get format(): CompressedPixelFormat | undefined;
    set flipY(value: boolean);
    get flipY(): boolean | undefined;
    set generateMipmaps(value: boolean);
    get generateMipmaps(): boolean | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThCompressedTexture<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThCompressedTexture<any, any>, "th-compressedTexture", never, { "image": { "alias": "image"; "required": false; }; "mipmaps": { "alias": "mipmaps"; "required": false; }; "format": { "alias": "format"; "required": false; }; "flipY": { "alias": "flipY"; "required": false; }; "generateMipmaps": { "alias": "generateMipmaps"; "required": false; }; }, {}, never, ["*"], false, never>;
}
