import { Type } from '@angular/core';
import { MOUSE, Raycaster, TOUCH } from 'three';
import { DragControls, DragControlsEventMap } from 'three/examples/jsm/controls/DragControls.js';
import { Camera } from 'three/src/cameras/Camera.js';
import { Object3D } from 'three/src/core/Object3D.js';
import { Vector3 } from 'three/src/math/Vector3.js';
import { ThControlBase } from '../ThControlBase';
import * as i0 from "@angular/core";
export declare class ThDragControls<T extends DragControls = DragControls, TARGS = [
    objects: Object3D[],
    camera: Camera,
    domElement?: HTMLElement | null
]> extends ThControlBase<DragControlsEventMap, T, TARGS> {
    getType(): Type<DragControls>;
    set objects(value: Object3D[]);
    get objects(): Object3D[] | undefined;
    set recursive(value: boolean);
    get recursive(): boolean | undefined;
    set transformGroup(value: boolean);
    get transformGroup(): boolean | undefined;
    set rotateSpeed(value: number);
    get rotateSpeed(): number | undefined;
    set raycaster(value: Raycaster | [origin: Vector3, direction: Vector3]);
    get raycaster(): Raycaster | undefined;
    set mouseButtons(value: {
        LEFT?: MOUSE | null | undefined;
        MIDDLE?: MOUSE | null | undefined;
        RIGHT?: MOUSE | null | undefined;
    });
    get mouseButtons(): {
        LEFT?: MOUSE | null | undefined;
        MIDDLE?: MOUSE | null | undefined;
        RIGHT?: MOUSE | null | undefined;
    } | undefined;
    set touches(value: {
        ONE?: TOUCH | null | undefined;
    });
    get touches(): {
        ONE?: TOUCH | null | undefined;
    } | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThDragControls<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ThDragControls<any, any>, "th-dragControls", never, { "objects": { "alias": "objects"; "required": false; }; "recursive": { "alias": "recursive"; "required": false; }; "transformGroup": { "alias": "transformGroup"; "required": false; }; "rotateSpeed": { "alias": "rotateSpeed"; "required": false; }; "raycaster": { "alias": "raycaster"; "required": false; }; "mouseButtons": { "alias": "mouseButtons"; "required": false; }; "touches": { "alias": "touches"; "required": false; }; }, {}, never, ["*"], false, never>;
}
